#!-PERL-
# f2htranslate.pl
# Copyright : Norwegian Telecom Research, 1993
# Programming : Jon Stephenson von Tetzchner
# This file can be changed and modified as long as this
# header is kept intact. This code can not be included
# in a commercial product.

# This script is part of the fm2html package.

# Input:  <miffile> with ".mif" stripped, i.e. <basename>
# Output: <basename>.tmp.head.0011.

$INFILE = $ARGV[0];
if ( ! -e "$INFILE.mif" )
{
  print "f2htranslate: File $INFILE.mif does not exist\n";
  exit;
}

$INFILE = $ARGV[0];
$OUTFILE = $ARGV[1];
$ENV{'INDEXFilename'} = $ARGV[2];
$ENV{'TITLEFilename'} = $ARGV[3];
$ENV{'TITLE'} = $ARGV[4];

$ENV{'TRANSFilename'} = $INFILE;

print "f2htranslate: Starting translation of MIF file $INFILE.mif to $OUTFILE\n";

&extractmifhead ($INFILE);
system("trans < $INFILE.mif");
system("cat $INFILE.tmp.000T $INFILE.tmp.000P | instext | insertcharacters > $OUTFILE");
open (OUTF, ">> $OUTFILE") || die ("f2htranslate: Could not open file \"$OUTFILE\"");
print OUTF "<A NAME=\"ENDFILE\"><PRE> </PRE></A>";

system("rm -f $INFILE.tmp.000T $INFILE.tmp.000P");
system("rm -f $INFILE.tmp.head.0011");
close (OUTF);

# extractmifhead
# Extracts Paragraph catalog, Font catalog and document part of a MIF file. 
# Adds a special paragraph format (normal text) to be used by the mif2gif
# filter.
# Input:  <miffile> with ".mif" stripped, i.e. <basename>
# Output: <basename>.tmp.head.0011.
sub extractmifhead
{

    $| = 1;
    local($INFILE) = @_;
    $PID = $$;

    open (INF, "<$INFILE.mif") ||
	die ("f2htranslate: extractmifhead: Could not open file $INFILE... exiting\n");
    open (OUTF, ">$INFILE.tmp.head.0011") ||
	die ("f2htranslate: extractmifhead: Could not open temporary file $INFILE.tmp.head.0011 for writing... exiting\n");

    $INSIDE = 0;

    print OUTF "<MIFFile 3.00> # Generated by Jon S. v. Tetzchner\n";

    while (<INF>)
	{
	    if (/<PgfCatalog/ || /<FontCatalog/ || /<Document /)
		{
		    $INSIDE = 1;
		    print OUTF;
		}
	    elsif (/> # end of FontCatalog/ || /> # end of Document/)
		{
		    $INSIDE = 0;
		    print OUTF;
		}
	    elsif (/> # end of PgfCatalog/)
		{
		    $INSIDE = 0;
		    $ENDPGF = $_;
		    print OUTF " <Pgf\n";
		    print OUTF "  <PgfTag `frame2htmlspecialparagraphformat'>\n";
		    print OUTF "  <PgfUseNextTag No >\n";
		    print OUTF "  <PgfNextTag `'>\n";
		    print OUTF "  <PgfAlignment LeftRight >\n";
		    print OUTF "  <PgfFIndent  0.0 cm>\n";
		    print OUTF "  <PgfLIndent  0.0 cm>\n";
		    print OUTF "  <PgfRIndent  0.0 cm>\n";
		    print OUTF "  <PgfTopSeparator `'>\n";
		    print OUTF "  <PgfBotSeparator `'>\n";
		    print OUTF "  <PgfPlacement Anywhere >\n";
		    print OUTF "  <PgfSpBefore  4.0 pt>\n";
		    print OUTF "  <PgfSpAfter  2.0 pt>\n";
		    print OUTF "  <PgfWithPrev No >\n";
		    print OUTF "  <PgfWithNext No >\n";
		    print OUTF "  <PgfBlockSize 2>\n";
		    print OUTF "  <PgfFont \n";
		    print OUTF "   <FTag `'>\n";
		    print OUTF "   <FFamily `Times'>\n";
		    print OUTF "   <FVar `Regular'>\n";
		    print OUTF "   <FWeight `Regular'>\n";
		    print OUTF "   <FAngle `Regular'>\n";
		    print OUTF "   <FSize  12.0 pt>\n";
#	            print OUTF "   <FUnderline No >\n";
		    print OUTF "   <FOverline No >\n";
		    print OUTF "   <FStrike No >\n";
#		    print OUTF "   <FSupScript No >\n";
#		    print OUTF "   <FSubScript No >\n";
		    print OUTF "   <FChangeBar No >\n";
		    print OUTF "   <FOutline No >\n";
		    print OUTF "   <FShadow No >\n";
		    print OUTF "   <FPairKern No >\n";
#		    print OUTF "   <FDoubleUnderline No >\n";
#		    print OUTF "   <FNumericUnderline No >\n";
		    print OUTF "   <FDX  0.0 pt>\n";
		    print OUTF "   <FDY  0.0 pt>\n";
		    print OUTF "   <FDW  0.0 pt>\n";
		    print OUTF "   <FSeparation 0>\n";
		    print OUTF "  > # end of PgfFont\n";
		    print OUTF "  <PgfLineSpacing Proportional >\n";
		    print OUTF "  <PgfLeading  2.0 pt>\n";
		    print OUTF "  <PgfAutoNum No >\n";
		    print OUTF "  <PgfNumTabs 0>\n";
		    print OUTF "  <PgfHyphenate Yes >\n";
		    print OUTF "  <HyphenMaxLines 4>\n";
		    print OUTF "  <HyphenMinPrefix 2>\n";
		    print OUTF "  <HyphenMinSuffix 2>\n";
		    print OUTF "  <HyphenMinWord 5>\n";
		    print OUTF "  <PgfLetterSpace No >\n";
		    print OUTF "  <PgfMinWordSpace 75>\n";
		    print OUTF "  <PgfOptWordSpace 100>\n";
		    print OUTF "  <PgfMaxWordSpace 125>\n";
		    print OUTF "  <PgfLanguage USEnglish >\n";
		    print OUTF "  <PgfCellAlignment Top >\n";
		    print OUTF "  <PgfCellMargins  0.0 pt 0.0 pt 0.0 pt 0.0 pt>\n";
		    print OUTF "  <PgfCellLMarginFixed No >\n";
		    print OUTF "  <PgfCellTMarginFixed No >\n";
		    print OUTF "  <PgfCellRMarginFixed No >\n";
		    print OUTF "  <PgfCellBMarginFixed No >\n";
		    print OUTF " > # end of Pgf\n";
		    print OUTF "$ENDPGF";
		}
	    elsif ($INSIDE)
		{
		    if (/<DTwoSides/)
			{
			    print OUTF " <DTwoSides No >\n";
			}
		    elsif (/<DPageRounding/)
			{
			    print OUTF " <DPageRounding DeleteEmptyPages >\n";
			}
		    else
			{	
			    print OUTF;
			}
		}
	}
    close (INF);
    close (OUTF);
}



