/*********************************************************/
/* trans.h						 */
/* Copyright : Norwegian Telecom Research, 1993		 */
/* Programming : Jon Stephenson von Tetzchner		 */
/* This file can be changed and modified as long as this */
/* header is kept intact. This code can not be included	 */
/* in a commercial product.				 */
/*********************************************************/

#ifndef TRANS_H
#define TRANS_H

struct FMCellLine
{
    char *fmline;
    struct FMCellLine *next_line;
};


struct FMCell
{
    int num_lines;
    struct FMCellLine *line;
    struct FMCell *next_cell;
};


struct FMRow
{
    int max_num_lines;
    struct FMCell *cell;
    struct FMRow *next_row;
};


struct FMTable
{
    int id;
    int num_columns;
    int *column_widths;
    char *table_title;
    struct FMRow *header;
    struct FMRow *footer;
    struct FMRow *row;
    struct FMTable *next_table;
    int table_ref;
    char *footnote[20];
    int footnote_def_nr;
};

#if defined(__STDC__)

void PrintHeaderTypeEnd(void);
int HeaderType(void);
void StartPrint(void);
void EndPrint(void);
void SetPageNum(void);
void InsertFootnote(void);
void PrintFootnotes(void);
void NewFootnoteStart(void);
void NewFootnoteEnd(void);
void InsertReferenceStart(void);
void InsertReferenceEnd(void);
int PrintReferences(void);
int ReferenceType(void);
void AFramesStart(void);
void AFramesEnd(void);
void AFrameUse(void);
int TableAFrameUse(void);
char *GetContents(void);
char *GetHdr(void);
void  SetReferenceNumber(void);
void SetReferenceFile(void);
void  SetMarker(void);
int GetNumber(void);
void NewParagraph(void);
void ParagraphNumber(void);
void EndParagraph(void);
void SetMarkerType(void);


void TableUse(void);
void  GetTableID(void);
void  GetTableNumColumns(void);
void  TableStart(void);
void  TableEnd(void);
void  TablesStart(void);
void  TablesEnd(void);
void  TableTitleStart(void);
void TableTitleEnd(void);
int GetID(void);
void InsertTable(FILE *f, int id);
int PrintTableString(void);
int PrintTable(void);
void PrintTableRow(FILE *f, struct FMRow *row, int *column_widths);
void PrintTableCell(FILE *f, struct FMCell *cell, int line_nr, int width);
void PrintTableFootnotes(FILE *f, struct FMTable *table);
struct FMTable *FindTable(int id);
int GetFrameType(int);
void StripSpace(char *);
char *GetTextOnly(char *);
void DoFrame(void);
int IsIndent(int tag);
int IsBullet(int tag);
int IsMark(int tag);
int IsNumber(int tag);
int IsList(int tag);    
int IsContinue(int tag);
int Level(int tag);
int ListType(int tag);
void TCDescend(int tclevels);
void TCAscend(int tclevels);
void Descend(int list_type, int levels);
void Ascend(int levels);
void PrintString(void);
void SetPgfTag(void);
void PrintHeaderTypeStart(void);
void UseString(char *string_contents);
void GetReferenceFile(void);
void FrameStart(void);
void FrameEnd(void);
int GetIDNextLine(void);
void ChangeOutputFile(void);
void PrintTextRectID(void);
void FontStart(void);
void FontEnd(void);
void ResetFont(void);
void ChangeFont(void);
void InsertSpecialChar(void);
void TextRect(void);
void InsertFigure(FILE *f, int idf);
void InsertInlineFigure(FILE *f, int idf);
void SetFrameType(void);
void ChangeFontWeight(void);
void ChangeFontAngle(void);
void ChangeFontUnderline(void);
void ChangeFontSubscript(void);
void ChangeFontSupscript(void);
void EndTextFlow(void);
void InlineFrameStart(void);
void InlineFrameEnd(void);
void TableHeadStart(void);
void TableHeadEnd(void);
void TableFootStart(void);
void TableFootEnd(void);
void TableRowStart(void);
void TableRowEnd(void);
void TableCellStart(void);
void TableCellEnd(void);
void NewCellLine(void);
int DoesTitleExist(char *);
void HandleParaLine(void);
void MergeMarkerWithString(char *, char *, char *);
#else

void PrintHeaderTypeStart();
void PrintHeaderTypeEnd();
int HeaderType();
void StartPrint();
void EndPrint();
void SetPageNum();
void InsertFootnote();
void PrintFootnotes();
void NewFootnoteStart();
void NewFootnoteEnd();
void InsertReferenceStart();
void InsertReferenceEnd();
int PrintReferences();
int ReferenceType();
void AFramesStart();
void AFramesEnd();
void AFrameUse();
int TableAFrameUse();
char *GetContents();
char *GetHdr();
void SetReferenceNumber();
void SetReferenceFile();
void SetMarker();
int GetNumber();
void NewParagraph();
void ParagraphNumber();
void EndParagraph();
void SetMarkerType();

void TableUse();
void GetTableID();
void GetTableNumColumns();
void TableStart();
void TableEnd();
void TablesStart();
void TablesEnd();
void TableTitleStart();
void TableTitleEnd();
int GetID();
void InsertTable();
void PrintTableString();
void PrintTable();
void PrintTableRow();
void PrintTableCell();
void PrintTableFootnotes();
struct FMTable *FindTable();
int GetFrameType();
void StripSpace();
char *GetTextOnly();
void DoFrame();
int IsIndent();
int IsBullet();
int IsMark();
int IsNumber();
int IsList();
int IsContinue();    
int Level();
int ListType();
void TCDescend();
void TCAscend();
void Descend();    
void Ascend();
void PrintString();
void SetPgfTag();
void PrintHeaderTypeStart();
void UseString();
void GetReferenceFile();
void FrameStart();
void FrameEnd();
int GetIDNextLine();
void ChangeOutputFile();
void PrintTextRectID();
void FontStart();
void FontEnd();
void ResetFont();
void ChangeFont();
void InsertSpecialChar();
void TextRect();
void InsertFigure();
void InsertInlineFigure();
void SetFrameType();
void ChangeFontWeight();
void ChangeFontAngle();
void ChangeFontUnderline();
void ChangeFontSubscript();
void ChangeFontSupscript();
void EndTextFlow();
void InlineFrameStart();
void InlineFrameEnd();
void TableHeadStart();
void TableHeadEnd();
void TableFootStart();
void TableFootEnd();
void TableRowStart();
void TableRowEnd();
void TableCellStart();
void TableCellEnd();
void NewCellLine();
int DoesTitleExist();
void HandleParaLine();
void MergeMarkerWithString();


#endif

extern char *reference_filename;
extern int reference_number;
extern int in_table;

extern struct FMTable *first_table;
extern struct FMTable *current_table;
extern struct FMRow *current_row;
extern struct FMCell *current_cell;
extern struct FMCellLine *current_cell_line;

#endif TRANS_H

